/*static char *SCCSID = "%w% %e%";*/
/**************************************************************************
 *
 * SOURCE FILE NAME =  CMDPDEFS.H
 *
 * DESCRIPTIVE NAME =
 *
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *             IBM CONFIDENTIAL
 *
 * VERSION = V2.1
 *
 * DATE = 94/03/14
 *
 * DESCRIPTION : Token IDs
 *
 * Purpose:  This file is automatically included in the files
 *           which generate the parser tables:
 *
 *             CMDPDSKT.C - Command Table for Diskette ADDs
 *             CMDPDISK.C - Command Table for ST-506 DASD ADDs
 *             CMDPSCSI.C - Command Table for SCSI ADDs
 *
 *
 * CHANGE ACTIVITY =
 *   DATE      FLAG        APAR   CHANGE DESCRIPTION
 *   --------  ----------  -----  --------------------------------------
 *   mm/dd/yy  @Vnnnnn     XXXXX  XXXXXXX
 *   08/31/94  d79396             DCR#79396 Add code to support some japan
 *                                unique medias.
 *   11/27/95  @V143950    PJ20893 Define TOK_ID_APM
 *
 *   03/29/96  @V149969           Add support for warm docking and warm device
 *                                swap.
 *
 ****************************************************************************/


/*                                                            */
/* TOKEN IDs  - opt.id definitions                            */
/*                                                            */
/* note:  - Assign a unique token id (1 - 255) for each valid */
/*          option.                                           */
/*                                                            */

#define TOK_ID_ADAPTER        1
#define TOK_ID_PORT           2
#define TOK_ID_UNIT           3
#define TOK_ID_DMA            4
#define TOK_ID_IRQ            5
#define TOK_ID_AHS            6
#define TOK_ID_NOT_AHS        7
#define TOK_ID_FORMAT         8
#define TOK_ID_S_BYTES        9
#define TOK_ID_MCA           10
#define TOK_ID_PS2           TOK_ID_MCA
#define TOK_ID_SLOT          11
#define TOK_ID_DM            12
#define TOK_ID_NOT_DM        13
#define TOK_ID_SM            14
#define TOK_ID_NOT_SM        15
#define TOK_ID_HCW           16
#define TOK_ID_NOT_HCW       17
#define TOK_ID_HCR           18
#define TOK_ID_NOT_HCR       19
#define TOK_ID_DEV0          20
#define TOK_ID_CAM           21
#define TOK_ID_NOT_CAM       22
#define TOK_ID_FDT           23
#define TOK_ID_NOT_FDT       24
#define TOK_ID_GEO           25
#define TOK_ID_SMS           26
#define TOK_ID_NOT_SMS       27
#define TOK_ID_SN            28
#define TOK_ID_NOT_SN        29
#define TOK_ID_ET            30
#define TOK_ID_NOT_ET        31
#define TOK_ID_CHGLINE       32
#define TOK_ID_TIMEOUT       33
#define TOK_ID_IGNORE        34
#define TOK_ID_V             35
#define TOK_ID_NOT_V         36
#define TOK_ID_LBAMODE       37
#define TOK_ID_RESET         38
#define TOK_ID_NORESET       39
#define TOK_ID_NO_MS         40
#define TOK_ID_MS            41
#define TOK_ID_DUALSP        42
#define TOK_ID_NT12          43                                         //@IBM J-d79396(A)
#define TOK_ID_APM           44                          /* @V143950 */
#define TOK_ID_FORCE         45                                     //@V149969
