/*static char *SCCSID = "%w% %e%";*/
/**************************************************************************
 *
 * SOURCE FILE NAME = FLP1EXTN.H
 *
 * DESCRIPTIVE NAME = External data declarations.
 *
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *             IBM CONFIDENTIAL
 *
 * VERSION = V2.1
 *
 * DATE = 94/03/14
 *
 * DESCRIPTION : Data External References
 *
 * Purpose:  This file provides external references for global
 *           data contained in FLP1DATA.C
 *
 *
 *
 *
 * CHANGE ACTIVITY =
 *   DATE      FLAG        APAR   CHANGE DESCRIPTION
 *   --------  ----------  -----  --------------------------------------
 *   mm/dd/yy  @Vnnnnn     XXXXX  XXXXXXX
 *
 *   08/31/94  @V98451            Add Resource Manger
 *
 *   08/31/94  d79396             DCR#79396 Add code to support some japan
 *                                unique medias.
 *   11/27/95  @V143950  PJ20893  Add APM data
 *
 *   03/29/96  @V149969           Add support for warm docking and warm device
 *                                swap.
 ****************************************************************************/

/*------------------------------------------------------------------------*/
/*                                                                        */
/* Global Static Data                                                     */
/*                                                                        */
/*------------------------------------------------------------------------*/

extern ACBPTRS    ACBPtrs[MAX_ADAPTERS];

extern VOID       (NEAR *ReqRoutine[])(NPACB npACB);

extern PFN        Device_Help;
extern HDRIVER    hDriver;        /*V98451*/


extern USHORT     ADDHandle;
extern USHORT     cAdapters;
extern USHORT     cUnits;

extern USHORT     Calibrate;
extern ULONG      MSRWaitCount;
extern ULONG      IODelayCount;

extern LIN        plDataSeg;

extern LIN        plSwapCode;
extern USHORT     SwapCodeLen;

extern USHORT     ADDLockCount;
extern LIN        plADDLockHandle;
extern UCHAR      ADDLockHandle[12];

extern PULONG     pCurIntLvl;

extern ULONG      ADDMotorIdleHandle;

extern USHORT     InitComplete;

extern USHORT     uCMachine;

extern UCHAR      AdapterName[18];

extern HWRESOURCE HWResource[MAX_ADAPTERS];

extern UCHAR      IRQUseCount[16];

extern USHORT     Specify1Backup;                                       //@IBM J-d79396(A)
extern USHORT     DataRateBackup;                                       //@IBM J-d79396(A)
extern USHORT     J_NT12Switch;                                         //@IBM J-d79396(A)
extern USHORT     AdaptersForced;                                   //@V149969(A)
extern USHORT     APMSuspended;                                     //@V149969(A)

/*------------------------------------------------------------------------*/
/*                                                                        */
/*      Area to build Control Blocks                                      */
/*                                                                        */
/*------------------------------------------------------------------------*/

extern USHORT   ACBPoolAvail;
extern NPBYTE   npACBPool;
extern UCHAR    ACBPool[ACB_POOL_SIZE+TIMER_POOL_SIZE];


/*------------------------------------------------------------------------*/
/*                                                                        */
/*      Initialization Data                                               */
/*                                                                        */
/*------------------------------------------------------------------------*/

/*------------------------------------*/
/*                                    */
/*                                    */
/*                                    */
/*------------------------------------*/
extern  NPUCB   npUCBLast;
extern  USHORT  FLP1IOWait;
extern  USHORT  BIOSUnit;
extern  USHORT  IBMModel;
extern  USHORT  IBMSubModel;

/*------------------------------------*/
/*                                    */
/*                                    */
/*                                    */
/*------------------------------------*/

                                                                    //@V149969
extern CONFIG_LINE    NewConfigLine;
extern ATBL     AdapterTable[MAX_ADAPTERS];

extern PDDD_PARM_LIST pDDD_Parm_List;

/*------------------------------------*/
/*                                    */
/*                                    */
/*                                    */
/*------------------------------------*/

extern ULONG           CalibrateTimerHandle;
extern USHORT          CallWorkerSync;
extern USHORT          CallWorker;

extern USHORT          Verbose;
extern USHORT          uCInstall;
extern USHORT          DockState;                                   //@V149969(A)

/*------------------------------------*/
/*                                    */
/* ASCII Text Data                    */
/*                                    */
/*------------------------------------*/

extern MSGTABLE  InitMsg;
extern NPSZ AdptMsgs[];
extern NPSZ UnitMsgs[];
extern NPSZ UnitType[];
extern NPSZ AdptOpts[];
extern NPSZ UnitOpts[];
extern NPSZ MsgNull;
extern UCHAR MsgForce[];                                            //@V149969(A)
extern UCHAR UninstallMsg[];
extern UCHAR ParmErrMsg[];
extern UCHAR VersionMsg[];

/*------------------------------------*/
/*                                    */
/* Media tables                       */
/*                                    */
/*------------------------------------*/

extern MEDIAINFO        MediaTable_0360;
extern MEDIAINFO        MediaTable_0362;
extern MEDIAINFO        MediaTable_1200;
extern MEDIAINFO        MediaTable_0720;
extern MEDIAINFO        MediaTable_1440;
extern MEDIAINFO        MediaTable_2880;
extern MEDIALOOKUP      MediaLookUp[MAX_FORM_FACTOR];

extern USHORT           SRTRate[4];
extern USHORT           HLTDelay15ms[4];

/*-------------------------------------------------------------------*/
/*                                                                   */
/*      Command Line Parser Data                                     */
/*                                                                   */
/*                                                                   */
/*-------------------------------------------------------------------*/

#include "cmdphdr.h"
#include "apmioctl.h"                                        /* @V143950 */

extern PSZ          pcmdline1;
extern PSZ          pcmdline_slash;
extern PSZ          pcmdline_start;
extern INT          tokv_index;
extern INT          state_index;
extern INT          length;
extern CHARBYTE     tokvbuf[];
extern POPT         pend_option;
extern POPT         ptable_option;
extern BYTE         *poutbuf1;
extern BYTE         *poutbuf_end;
extern CC           cc;
extern USHORT       outbuf_len;
extern PBYTE        poutbuf;
extern OPTIONTABLE  opttable;
extern USHORT       DrvrNameSize;        /*V98451*/
extern DRIVERSTRUCT DriverStruct;        /*V98451*/
extern ADAPTERSTRUCT AdapterStruct;      /*V98451*/
extern DEVICESTRUCT DevStruct;           /*V98451*/
extern UCHAR        ResourceBuf[];       /*V98451*/
extern PAHRESOURCE  pResourceList;       /*V98451*/

extern USHORT      APMAttached;              /* @V143950 */
extern IDCTABLE    IDCTable;                 /* @V143950 */
extern UCHAR       APMName[];                /* @V143950 */
extern PFN         APMAdd;                   /* @V143950 */
extern APMIDC_NOTIFY_PKT APMSendEventPkt;    /* @V143950 */
extern USHORT      APMFlag;                  /* @V143950 */
extern USHORT      APMDisabled;              /* @V143950 */
