/*static char *SCCSID = "src/dev/dasd/ibm/ibm1s506/s506ps2.h, idsk, r207, 8.005p 93/03/18";*/
/**************************************************************************
 *
 * SOURCE FILE NAME =  S506PS2.H
 *
 * DESCRIPTIVE NAME =  IBM1S506.ADD - Adapter Driver for ST506/IDE DASD
 *
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *             IBM CONFIDENTIAL
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION : IBM PS/2 specific hardware equates
 *
 * Purpose:
 *
 *
 *
 *
 *
 * CHANGE ACTIVITY =
 *   DATE      FLAG        APAR   CHANGE DESCRIPTION
 *   --------  ----------  -----  --------------------------------------
 *   mm/dd/yy  @Vnnnnn     XXXXX  XXXXXXX
 *   04/03/95  @V117508   117508  Add #defines to include MCA version of driver
 *   06/22/95  @V126821   197070  Identify the MACH5 submodel for init time
 *
 ****************************************************************************/

/*------------------------------------*/
/* System Control Port A              */
/*------------------------------------*/
#define PS2_CTRL_PORT_A           0x0092
#define PS2_FIXED_DISK_LIGHT      0xc0

/*------------------------------------*/
/* System Board Enable/Setup Register */
/*------------------------------------*/
#define PS2_SETUP_REG             0x0094
#define PS2_DISABLE_PLANAR_SETUP  0x80
#define PS2_DISABLE_VIDEO_SETUP   0x20

/*------------------------------------*/
/* PLANAR COM/PARALLEL/DSKT Pos Reg   */
/*------------------------------------*/
#define PS2_PLANAR_POS_REG        0x0102
#define ENABLE_FIXED_POS          0x01

/*------------------------------------*/
/* PLANAR Fixed Drive Pos Reg         */
/*------------------------------------*/
#define PS2_FIXED_POS_REG         0x0103
#define ENABLE_FIXED_DRIVE        0x08
#define REG_3F7_TO_DSKT           0x04
#define REG_3F6_TO_DSKT           0x02

/*----------------------------*/
/* Machine Model/Type Bytes   */
/*----------------------------*/
#define MCHID_30286               0xFC09


#ifdef MCA                                                         /*@V117508*/
                                                                   /*VVVVVVVV*/
/*------------------------------------*/
/* LACUNA Spcific defines             */
/*------------------------------------*/

#define LACUNA                  1
#define NOT_LACUNA              0

#define LACUNA_MODEL                  0x00F8
#define LACUNA_SUBMODEL               0x00B0
#define MACH5_SUBMODEL                0x0039                       /*@V126821*/

#define LACUNA_SECURITY_OVERRIDE_PORT 0x00E3
#define LACUNA_IRQ                        14
#define LACUNA_IDE_STATUS_PORT_ACTIVE 0x0010  /* bit 4 */
#define LACUNA_IDE_IRQ_STATUS_PORT    0x0092
#define LACUNA_IDE_IRQ_ACTIVE         0x0004  /* bit 2 */


/*------------------------------------*/
/* MCA/IDE Spcific defines            */
/*------------------------------------*/

#define MCA_IDE_IRQ_STATUS_PORT       0x007E
#define MCA_IDE_IRQ0                      14
#define MCA_IDE_IRQ1                      15
#define MCA_IDE_IRQ0_BIT              0x0002
#define MCA_IDE_IRQ1_BIT              0x0001
                                                                   /*AAAAAAAA*/
#endif                                                             /*@V117508*/
