/*static char *SCCSID = "src/dev/dasd/ibm/ibm1s506/s506timr.c, idsk, r207, 8.005p 93/03/18";*/
/**************************************************************************
 *
 * SOURCE FILE NAME = S506TIMR.C
 *
 * DESCRIPTIVE NAME = IBM1S506.ADD - Adapter Driver for ST506/IDE DASD
 *
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *             IBM CONFIDENTIAL
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION : Adapter Driver timer driven entry points.
 *
 * Purpose:
 *
 *
 *
 *
 *
 * CHANGE ACTIVITY =
 *   DATE      FLAG        APAR   CHANGE DESCRIPTION
 *   --------  ----------  -----  --------------------------------------
 *   01/06/96  @V147576           Merged CMD, added HWRESOURCE to fix
 *                                Suspend/Resume for multiple clients.
 *
 ****************************************************************************/

 #define INCL_NOBASEAPI
 #define INCL_NOPMAPI
 #define INCL_NO_SCB
 #define INCL_INITRP_ONLY
 #define INCL_DOSERRORS
 #include "os2.h"
 #include "dos.h"
 #include "bseerr.h"
 #include "dskinit.h"
 #include <scb.h>
 #include <abios.h>

 #include "iorb.h"
 #include "reqpkt.h"
 #include "dhcalls.h"
 #include "addcalls.h"

 #include "s506cons.h"
 #include "s506type.h"
 #include "s506regs.h"
 #include "s506ext.h"
 #include "s506pro.h"
 #include "s506misc.h"


/*------------------------------------*/
/*                                    */
/*                                    */
/*                                    */
/*------------------------------------*/

VOID FAR IRQTimer( ULONG TimerHandle, PACB pACB, ULONG Unused  )
{
  if ( TimerHandle != pACB->IRQTimerHandle )
  {
    _asm { int 3 }
  }

  ADD_CancelTimer( TimerHandle );


  pACB->IRQTimerHandle  = 0;
  pACB->TimerFlags     |= ACBT_IRQ;
  pACB->Flags          &= ~ACBF_INTERRUPT;

  if ( pACB->Flags & ACBF_WAITSTATE )
  {
    pACB->State = ACBS_ERROR;

    StartSM( (NPACB) pACB );                                        /*@V147576*/
  }
  else
  {
    _asm { int 3 }
  }
}

/*---------------------------------------------*/
/* DelayedRetry                                */
/* ------------                                */
/*                                             */
/*                                             */
/*                                             */
/*---------------------------------------------*/

VOID FAR DelayedRetry( ULONG hRetryTimer, PACB pACB, ULONG Unused )
{
  if ( pACB->RetryTimerHandle == hRetryTimer )
  {
    pACB->RetryTimerHandle = 0;
    ADD_CancelTimer( hRetryTimer );

    pACB->TimerFlags = 0;
    pACB->State = ACBS_RETRY;
    StartSM( (NPACB) pACB );                                        /*@V147576*/
  }
  else
  {
    _asm { int 3 }
  }

}

/*---------------------------------------------*/
/* DelayedReset                                */
/* ------------                                */
/*                                             */
/* This routine restarts the state machine to  */
/* determine if a reset has completed.         */
/*                                             */
/*---------------------------------------------*/

VOID FAR DelayedReset( ULONG hResetTimer, PACB pACB, ULONG Unused )
{
  if ( pACB->ResetTimerHandle == hResetTimer )
  {
    pACB->ResetTimerHandle = 0;
    ADD_CancelTimer( hResetTimer );

    pACB->State = ACBS_RESETCHECK;
    StartSM( (NPACB) pACB );                                        /*@V147576*/
  }
  else
  {
    _asm { int 3 }
  }

}

/*---------------------------------------------*/
/* ElapsedTimer                                */
/* ------------                                */
/*                                             */
/*                                             */
/*---------------------------------------------*/

VOID FAR ElapsedTimer( ULONG hElapsedTimer, ULONG Unused1, ULONG Unused2 )
{
  NPACB         npACB;
  USHORT        i;

  for ( i=0; i < MAX_ADAPTERS; i++ )
  {
    if ( npACB = ACBPtrs[i].npACB )
    {
      npACB->ElapsedTime += ELAPSED_TIMER_INTERVAL;
    }
  }
}

/*------------------------------------*/
/*                                    */
/*                                    */
/*                                    */
/*------------------------------------*/

VOID NEAR IODelay()
{
  ULONG   IODelayCtr = IODelayCount;

  while( IODelayCtr--)
    ;
}


