/*static char *SCCSID = "src/dev/dasd/ibm/ibm2adsk/adskcons.h, adsk, r206 93/03/20";*/
/**************************************************************************
 *
 * SOURCE FILE NAME =  ADSKCONS.H
 *
 * DESCRIPTIVE NAME =  IBM2ADSK.ADD - Adapter Driver for ABIOS DASD Devices
 *
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
 *	       Copyright Microsoft Corporation, 1990
 *	       LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *	       REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *	       RESTRICTED MATERIALS OF IBM
 *	       IBM CONFIDENTIAL
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION : Miscellaneous constants and macros
 *
 *
 *
 * CHANGE ACTIVITY =
 *   DATE      FLAG	   APAR   CHANGE DESCRIPTION
 *   --------  ----------  -----  --------------------------------------
 *   08/11/92  @V51599	   51599  Check for excessive interrupt nesting.
 *   02/05/94  @V78794	   78794  Added equates for memory/buffer sizes.
 *
 ****************************************************************************/


/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/

#define ENABLE	_asm{ sti }
#define DISABLE _asm{ cli }

/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/

#define ADDNAME 	       "IBM_ABIOS_DISK  "
#define ADDFLAGS	       0
#define DRIVERCLASS_ADD        1

/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/

#define SECTOR_SHIFT		9

/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/

#define MAX_CONFIG_DATA        (16*1024)
#define MAX_LIDS		32
#define MAX_HW_INT_LEVELS	4
#define MAX_SG_BUFFERS		4
#define MAX_INTERRUPT_NESTING	4				     /*@V51599*/

/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/

#define REQUEST_DONE		0
#define REQUEST_NOT_DONE	1
#define REQUEST_RETRY		2

/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/

#define STAGE_START		ABIOS_EP_START
#define STAGE_INT		ABIOS_EP_INTERRUPT

/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/

#define ABRC_PARMERROR		0x4000
#define ABRC_TIMEOUTERROR	0x2000
#define ABRC_DEVERROR		0x1000

/*---------------------------------------------------*/
/*						     */
/*						     */
/*---------------------------------------------------*/
#define STERR_GENERAL_FAILURE	0x810c

/*---------------------------------------------------*/
/* Memory size constants			     */
/*						     */
/*---------------------------------------------------*/
#define MEMSIZE_6MB    6291456L 	/* 6MB	*/		     /*@V78794*/
#define BUFSIZE_16K    0x4000L					     /*@V78794*/
#define BUFSIZE_32K    0x8000L					     /*@V78794*/
