/*static char *SCCSID = "@(#)testcfg.h  6.2 92/02/13";*/

/*** TCFGDATA.C - TESTCFG Device Driver Data Module
 *
 *      IBM Confidential
 *
 *      Copyright (c) IBM Corporation 1987, 1992
 *
 *      All Rights Reserved
 *
 *   DESCRIPTION
 *
 *     TESTCFG specific include information (defines, protocols, macros)
 *
 *   MODIFICATION HISTORY
 *
 * 6.1  09/17/94               Jon Grimm   Data moved into single module
 *      05/08/96               F.Schroeder Added IEEE-1284 Query Device ID
 *      06/24/96               F.Schroeder Fixed timeout problem with Deskjets
 */

#include "testcfg.h"
#include "IORB.h"
#include "SCSI.h"
#include "devclass.h"
#include "tcfgscsi.h"
#include "tcfgx.h"
#define RMCode SWAPCODE
#include "rmcalls.h"
#include "tcfgex.h"


/* Device Driver Header */
DEVICEHDR devhdr = {
            (void far *) 0xFFFFFFFF,                    /* link         */
            (DAW_GIO | DAW_CHR | DAW_OPN | DAW_LEVEL3), /* attribute    */
            (OFF) STRATEGYCFG,                          /* &strategy    */
            (OFF) 0,                                    /* &IDCroutine  */
            "TESTCFG$",                                 /* name/#units  */
            0,                                          /* prot cs */
            0,                                          /* prot ds */
            0,                                          /* real cs */
            0,                                          /* real ds */
            DEV_INITCOMPLETE
            };

ULONG    APMPresent = 0;
FPFUNCTION Device_Help= 0;

BIOSINFO BIOSInfo = {0};                            /* BIOS Level Information     */
ULONG    EisaCardID[CFG_MAX_EISA_SLOTS]={0};  /* planar id plus 15 adapters */
USHORT   POSCardID[CFG_MAX_POS_SLOTS+1]={0};  /* planar id plus 8 adapters  */
FLAG     fEisaPresent=0;                      /* flag for EISA presence     */
FLAG     fMCAPresent=0;                       /* flag for MCA  presence     */
FARPOINTER  pDataSeg=0L;                  /* virt ptr of our data segment   */
ULONG       ppDataSeg=0L;                 /* phys addr of our data segment  */

// 6.2 UCHAR InitMessage[] = "TESTCFG$ successfully installed.\r\n";
UCHAR FailMessage[] = "TESTCFG$ did not install. OEMHLP$ not present.\r\n";
UCHAR OEMHelp[] = "OEMHLP$";                  /* Name of OEM Help Dev Drvr  */
POSRB    RB={0};                              /* ABIOS request block        */
POSLENRB POSLenRB={0};
         /* Another ABIOS request block.  Must go to ABIOS to obtain the
            length of the RB to use with function 0xB (read POS data). */

IORB_CONFIGURATION ConfigIORB={0};
IORB_CDB           PassthruIORB={0};
IORB_UNIT_CONTROL  UnitControlIORB={0};
char   DeviceTableBuffer[MAX_DT_SIZE]={0};       /*Scratch buffer */
struct DevClassTableStruc far *pDriverTable={0}; /* ptr to registered ADD EPs */
INQUIRYDATA InquiryData = {0};                   /* Device Inquiry Data          */

USHORT         FilterADDHandle=0;
void           (far *DriverEP)()= NULL;  // Driver entry point
void           (far *DriverEPF)()=NULL; // Filter entry point



HDRIVER DriverHandle = 0;
PFNRM   RM_Help0 = 0;
ULONG   RMFlags  = 0;

